unit UProjectTemplates;

{$mode delphi}

interface

uses
  Classes, SysUtils, UProject;

type

  { TProjectTemplateConsoleApp }

  TProjectTemplateConsoleApp = class(TProjectTemplate)
    constructor Create; override;
    procedure InitProject(Project: TProject); override;
  end;

  { TProjectTemplateGUIApp }

  TProjectTemplateGUIApp = class(TProjectTemplate)
    constructor Create; override;
    procedure InitProject(Project: TProject); override;
  end;

  { TProjectTemplatePackage }

  TProjectTemplatePackage = class(TProjectTemplate)
    constructor Create; override;
    procedure InitProject(Project: TProject); override;
  end;

  { TProjectTemplateUnit }

  TProjectTemplateUnit = class(TProjectTemplate)
    constructor Create; override;
    procedure InitProject(Project: TProject); override;
  end;


implementation

{ TProjectTemplateUnit }

constructor TProjectTemplateUnit.Create;
begin
  inherited Create;
  Name := 'Unit';
end;

procedure TProjectTemplateUnit.InitProject(Project: TProject);
var
  NewFile: TProjectFile;
begin
  //inherited InitProject(Project);
  NewFile := Project.Files.AddFile('Unit1.pas');
  with NewFile.Source do begin
    Add('unit Unit1;');
    Add('');
    Add('interface');
    Add('');
    Add('implementation');
    Add('');
    Add('end.');
  end;
  Project.MainSource := NewFile;
end;

{ TProjectTemplatePackage }

constructor TProjectTemplatePackage.Create;
begin
  inherited Create;
  Name := 'Package';
end;

procedure TProjectTemplatePackage.InitProject(Project: TProject);
var
  NewFile: TProjectFile;
begin
  inherited InitProject(Project);
  NewFile := Project.Files.AddFile('Package1.bpl');
  with NewFile.Source do begin
    Add('package Package1;');
    Add('');
    Add('requires');
    Add('  RTL;');
    Add('');
    Add('end.');
  end;
  Project.MainSource := NewFile;
end;

{ TProjectTemplateGUIApp }

constructor TProjectTemplateGUIApp.Create;
begin
  inherited Create;
  Name := 'GUI application';
end;

procedure TProjectTemplateGUIApp.InitProject(Project: TProject);
var
  NewFile: TProjectFile;
begin
  inherited InitProject(Project);
  NewFile := Project.Files.AddFile('Project1.dpr');
  with NewFile.Source do begin
    Add('program Project1;');
    Add('');
    Add('uses');
    Add('  GUI;');
    Add('');
    Add('var');
    Add('  Application: TApplication');
    Add('begin');
    Add('  Application := TApplication.Create;');
    Add('  Application.Run;');
    Add('  Application.Free;');
    Add('end.');
  end;
  Project.MainSource := NewFile;
end;

{ TProjectTemplateConsoleApp }

constructor TProjectTemplateConsoleApp.Create;
begin
  inherited Create;
  Name := 'Console application';
end;

procedure TProjectTemplateConsoleApp.InitProject(Project: TProject);
var
  NewFile: TProjectFile;
begin
  inherited InitProject(Project);
  NewFile := Project.Files.AddFile('Project1.dpr');
  with NewFile.Source do begin
    Add('program Project1;');
    Add('');
    Add('begin');
    Add('end.');
  end;
  Project.MainSource := NewFile;
end;

end.

